;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega8535
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 128 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "ChCouleu.vec"
	.INCLUDE "ChCouleu.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R24,Z+
	LPM  R25,Z+
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0
;       1 /*********************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.0 Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2003 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : 
;      10 Version : 
;      11 Date    : 23/06/2008
;      12 Author  : perso                           
;      13 Company :                                 
;      14 Comments: 
;      15 
;      16 
;      17 Chip type           : ATmega8535
;      18 Program type        : Application
;      19 Clock frequency     : 8,000000 MHz
;      20 Memory model        : Small
;      21 External SRAM size  : 0
;      22 Data Stack size     : 128
;      23 *********************************************/
;      24 
;      25 #include <mega8535.h>
;      26 
;      27 // Librairies non gnres par Wizard ( rajouter manuellement)
;      28 //-----------------------------------------------------------------      
;      29 #include <stdio.h>    // contient la fonction sprintf 
;      30 #include <delay.h>    // contient la fonction delay_ms
;      31 
;      32 // Ces fichiers d'en-tte et les librairies correspondantes doivent tre placs
;      33 // dans les rpertoires c:/cvavr/inc et c:/cvavr/lib
;      34 // -------------------------------------------------------------------------------
;      35 #include <ssi.h> 	// Sous-programme Affiche_LCD, Lire_BP  
;      36 //**********************************************************************************  
;      37 
;      38 // Alphanumeric LCD Module functions
;      39 #asm
;      40    .equ __lcd_port=0x15
   .equ __lcd_port=0x15
;      41 #endasm

;      42 #include <lcd.h>
;      43 
;      44 // Declare your global variables here
;      45 
;      46 void main(void)
;      47 {

	.CSEG
_main:
;      48 // Declare your local variables here   
;      49 // -----------------------------------------------------------------------------------------
;      50 //type 		nom 					description  
;      51 // -----------------------------------------------------------------------------------------
;      52 char display_buffer_ligne0[17]; 			// tampon ligne 0 de l'afficheur
;      53 char display_buffer_ligne1[17]; 	       		// tampon ligne 1 de l'afficheur
;      54 
;      55 unsigned char R=0,R_1=0,V=0,V_1=0,B_1=0,B=0;	// intensit lumineuse
;      56 unsigned char BP;					// Bouton-poussoir slectionn
;      57  
;      58 // Coefficient pour le rglage du rapport cyclique du signal PWM
;      59 unsigned char alpha[11] = {0,25,51,76,102,127,153,178,204,229,255}; 
;      60 
;      61 // Input/Output Ports initialization
;      62 // Port A initialization
;      63 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
;      64 // State0=P State1=P State2=P State3=P State4=P State5=P State6=T State7=T 
;      65 PORTA=0x3F;
	SBIW R28,46
	LDI  R24,11
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x23*2)
	LDI  R31,HIGH(_0x23*2)
	RCALL __INITLOCB
;	display_buffer_ligne0 -> Y+29
;	display_buffer_ligne1 -> Y+12
;	R -> R16
;	R_1 -> R17
;	V -> R18
;	V_1 -> R19
;	B_1 -> R20
;	B -> R21
;	BP -> Y+11
;	alpha -> Y+0
	LDI  R16,0
	LDI  R17,0
	LDI  R18,0
	LDI  R19,0
	LDI  R20,0
	LDI  R21,0
	LDI  R30,LOW(63)
	OUT  0x1B,R30
;      66 DDRA=0x00;
	CLR  R30
	OUT  0x1A,R30
;      67 
;      68 // Port B initialization
;      69 // Func0=In Func1=In Func2=In Func3=Out Func4=In Func5=In Func6=In Func7=In 
;      70 // State0=T State1=T State2=T State3=0 State4=T State5=T State6=T State7=T 
;      71 PORTB=0x00;
	OUT  0x18,R30
;      72 DDRB=0x08;
	LDI  R30,LOW(8)
	OUT  0x17,R30
;      73 
;      74 // Port C initialization
;      75 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
;      76 // State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
;      77 PORTC=0x00;
	CLR  R30
	OUT  0x15,R30
;      78 DDRC=0x00;
	OUT  0x14,R30
;      79 
;      80 // Port D initialization
;      81 // Func0=In Func1=In Func2=In Func3=In Func4=Out Func5=Out Func6=In Func7=In 
;      82 // State0=T State1=T State2=T State3=T State4=0 State5=0 State6=T State7=T 
;      83 PORTD=0x00;
	OUT  0x12,R30
;      84 DDRD=0x30;
	LDI  R30,LOW(48)
	OUT  0x11,R30
;      85 
;      86 // Timer/Counter 0 initialization
;      87 // Clock source: System Clock
;      88 // Clock value: 31,250 kHz
;      89 // Mode: Phase correct PWM top=FFh
;      90 // OC0 output: Non-Inverted PWM
;      91 TCCR0=0x64;
	LDI  R30,LOW(100)
	OUT  0x33,R30
;      92 TCNT0=0x00;
	CLR  R30
	OUT  0x32,R30
;      93 OCR0=0x00;
	OUT  0x3C,R30
;      94 
;      95 // Timer/Counter 1 initialization
;      96 // Clock source: System Clock
;      97 // Clock value: 31,250 kHz
;      98 // Mode: Ph. correct PWM top=00FFh
;      99 // OC1A output: Non-Inv.
;     100 // OC1B output: Non-Inv.
;     101 // Noise Canceler: Off
;     102 // Input Capture on Falling Edge
;     103 TCCR1A=0xA1;
	LDI  R30,LOW(161)
	OUT  0x2F,R30
;     104 TCCR1B=0x04;
	LDI  R30,LOW(4)
	OUT  0x2E,R30
;     105 TCNT1H=0x00;
	CLR  R30
	OUT  0x2D,R30
;     106 TCNT1L=0x00;
	OUT  0x2C,R30
;     107 OCR1AH=0x00;
	OUT  0x2B,R30
;     108 OCR1AL=0x00;
	OUT  0x2A,R30
;     109 OCR1BH=0x00;
	OUT  0x29,R30
;     110 OCR1BL=0x00;
	OUT  0x28,R30
;     111 
;     112 // Timer/Counter 2 initialization
;     113 // Clock source: System Clock
;     114 // Clock value: Timer 2 Stopped
;     115 // Mode: Normal top=FFh
;     116 // OC2 output: Disconnected
;     117 ASSR=0x00;
	OUT  0x22,R30
;     118 TCCR2=0x00;
	OUT  0x25,R30
;     119 TCNT2=0x00;
	OUT  0x24,R30
;     120 OCR2=0x00;
	OUT  0x23,R30
;     121 
;     122 // External Interrupt(s) initialization
;     123 // INT0: Off
;     124 // INT1: Off
;     125 // INT2: Off
;     126 MCUCR=0x00;
	OUT  0x35,R30
;     127 MCUCSR=0x00;
	OUT  0x34,R30
;     128 
;     129 // Timer(s)/Counter(s) Interrupt(s) initialization
;     130 TIMSK=0x00;
	OUT  0x39,R30
;     131 
;     132 // Analog Comparator initialization
;     133 // Analog Comparator: Off
;     134 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     135 // Analog Comparator Output: Off
;     136 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     137 SFIOR=0x00;
	CLR  R30
	OUT  0x30,R30
;     138 
;     139 // LCD module initialization
;     140 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	RCALL _lcd_init
;     141 
;     142 sprintf(display_buffer_ligne0,"Rouge Vert Bleu");
	RCALL SUBOPT_0x0
	__POINTW1FN _34,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     143 sprintf(display_buffer_ligne1,"%-u%%  %-u%%  %-u%%",R,V,B);
	__POINTW1FN _34,16
	RCALL SUBOPT_0x2
	LDI  R24,12
	RCALL SUBOPT_0x3
;     144 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x4
;     145 
;     146 while (1)
_0x24:
;     147       {
;     148       BP = Lire_BP();
	RCALL _Lire_BP
	STD  Y+11,R30
;     149       if ((R != R_1) || (V != V_1) || (B != B_1))
	CP   R17,R16
	BRNE _0x28
	CP   R19,R18
	BRNE _0x28
	CP   R20,R21
	BREQ _0x27
_0x28:
;     150       {
;     151          sprintf(display_buffer_ligne0,"Rouge Vert Bleu");
	RCALL SUBOPT_0x0
	__POINTW1FN _34,36
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     152          sprintf(display_buffer_ligne1,"%-u%%  %-u%%  %-u%%",R,V,B);
	__POINTW1FN _34,52
	RCALL SUBOPT_0x2
	LDI  R24,12
	RCALL SUBOPT_0x3
;     153          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x4
;     154          R_1 = R; V_1 = V; B_1 = B;
	MOV  R17,R16
	MOV  R19,R18
	MOV  R20,R21
;     155       }
;     156          switch(BP)
_0x27:
	LDD  R30,Y+11
;     157           {
;     158             case INC: if (R < 90) R = R+10; else R = 100; break;
	CPI  R30,LOW(0x1F)
	BRNE _0x2D
	CPI  R16,90
	BRSH _0x2E
	SUBI R16,-LOW(10)
	RJMP _0x2F
_0x2E:
	LDI  R16,LOW(100)
_0x2F:
	RJMP _0x2C
;     159             case DEC: if (R > 10) R = R-10; else R = 0; break;
_0x2D:
	CPI  R30,LOW(0x2F)
	BRNE _0x30
	LDI  R30,LOW(10)
	CP   R30,R16
	BRSH _0x31
	SUBI R16,LOW(10)
	RJMP _0x32
_0x31:
	LDI  R16,LOW(0)
_0x32:
	RJMP _0x2C
;     160             case OK: if (V < 90) V = V+10; else V = 100; break;
_0x30:
	CPI  R30,LOW(0x37)
	BRNE _0x33
	CPI  R18,90
	BRSH _0x34
	SUBI R18,-LOW(10)
	RJMP _0x35
_0x34:
	LDI  R18,LOW(100)
_0x35:
	RJMP _0x2C
;     161             case SET: if (V > 10) V = V-10; else V = 0; break;
_0x33:
	CPI  R30,LOW(0x3D)
	BRNE _0x36
	LDI  R30,LOW(10)
	CP   R30,R18
	BRSH _0x37
	SUBI R18,LOW(10)
	RJMP _0x38
_0x37:
	LDI  R18,LOW(0)
_0x38:
	RJMP _0x2C
;     162             case ECHAP : if (B < 90) B = B+10; else B = 100; break;
_0x36:
	CPI  R30,LOW(0x3B)
	BRNE _0x39
	CPI  R21,90
	BRSH _0x3A
	SUBI R21,-LOW(10)
	RJMP _0x3B
_0x3A:
	LDI  R21,LOW(100)
_0x3B:
	RJMP _0x2C
;     163             case ENTR : if (B > 10) B = B-10; else B = 0; break;
_0x39:
	CPI  R30,LOW(0x3E)
	BRNE _0x2C
	LDI  R30,LOW(10)
	CP   R30,R21
	BRSH _0x3D
	SUBI R21,LOW(10)
	RJMP _0x3E
_0x3D:
	LDI  R21,LOW(0)
_0x3E:
;     164           }
_0x2C:
;     165         OCR1AL=alpha[R/10];
	MOV  R26,R16
	RCALL SUBOPT_0x5
	OUT  0x2A,R30
;     166         OCR1BL=alpha[V/10];
	MOV  R26,R18
	RCALL SUBOPT_0x5
	OUT  0x28,R30
;     167         OCR0=alpha[B/10];
	MOV  R26,R21
	RCALL SUBOPT_0x5
	OUT  0x3C,R30
;     168 
;     169       };
	RJMP _0x24
;     170 }
	ADIW R28,46
_0x3F:
	RJMP _0x3F
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G2:
	put:
	RCALL SUBOPT_0x6
	SBIW R30,0
	BREQ _0x76
	RCALL SUBOPT_0x6
	ADIW R30,1
	RCALL __PUTWP1
	SBIW R30,1
	MOVW R26,R30
	LDD  R30,Y+2
	ST   X,R30
	RJMP _0x77
_0x76:
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _putchar
_0x77:
	ADIW R28,3
	RET
__print_G2:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R16,0
_0x79:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,1
	STD  Y+16,R30
	STD  Y+16+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x7B
	MOV  R30,R16
	CPI  R30,0
	BRNE _0x7F
	CPI  R19,37
	BRNE _0x80
	LDI  R16,LOW(1)
	RJMP _0x81
_0x80:
	RCALL SUBOPT_0x7
_0x81:
	RJMP _0x7E
_0x7F:
	CPI  R30,LOW(0x1)
	BRNE _0x82
	CPI  R19,37
	BRNE _0x83
	RCALL SUBOPT_0x7
	LDI  R16,LOW(0)
	RJMP _0x7E
_0x83:
	LDI  R16,LOW(2)
	LDI  R21,LOW(0)
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0x84
	LDI  R17,LOW(1)
	RJMP _0x7E
_0x84:
	CPI  R19,43
	BRNE _0x85
	LDI  R21,LOW(43)
	RJMP _0x7E
_0x85:
	CPI  R19,32
	BRNE _0x86
	LDI  R21,LOW(32)
	RJMP _0x7E
_0x86:
	RJMP _0x87
_0x82:
	CPI  R30,LOW(0x2)
	BRNE _0x88
_0x87:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0x89
	ORI  R17,LOW(128)
	RJMP _0x7E
_0x89:
	RJMP _0x8A
_0x88:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x7E
_0x8A:
	CPI  R19,48
	BRLO _0x8D
	CPI  R19,58
	BRLO _0x8E
_0x8D:
	RJMP _0x8C
_0x8E:
	MOV  R26,R20
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	MOV  R20,R30
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x7E
_0x8C:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0x92
	RCALL SUBOPT_0x8
	LD   R30,X
	RCALL SUBOPT_0x9
	RJMP _0x93
_0x92:
	CPI  R30,LOW(0x73)
	BRNE _0x95
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0xA
	RCALL _strlen
	MOV  R16,R30
	RJMP _0x96
_0x95:
	CPI  R30,LOW(0x70)
	BRNE _0x98
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0xA
	RCALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0x96:
	ORI  R17,LOW(2)
	ANDI R17,LOW(127)
	LDI  R18,LOW(0)
	RJMP _0x99
_0x98:
	CPI  R30,LOW(0x64)
	BREQ _0x9C
	CPI  R30,LOW(0x69)
	BRNE _0x9D
_0x9C:
	ORI  R17,LOW(4)
	RJMP _0x9E
_0x9D:
	CPI  R30,LOW(0x75)
	BRNE _0x9F
_0x9E:
	LDI  R30,LOW(_tbl10_G2*2)
	LDI  R31,HIGH(_tbl10_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(5)
	RJMP _0xA0
_0x9F:
	CPI  R30,LOW(0x58)
	BRNE _0xA2
	ORI  R17,LOW(8)
	RJMP _0xA3
_0xA2:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0xD1
_0xA3:
	LDI  R30,LOW(_tbl16_G2*2)
	LDI  R31,HIGH(_tbl16_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(4)
_0xA0:
	SBRS R17,2
	RJMP _0xA5
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0xB
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0xA6
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R21,LOW(45)
_0xA6:
	CPI  R21,0
	BREQ _0xA7
	SUBI R16,-LOW(1)
	RJMP _0xA8
_0xA7:
	ANDI R17,LOW(251)
_0xA8:
	RJMP _0xA9
_0xA5:
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0xB
_0xA9:
_0x99:
	SBRC R17,0
	RJMP _0xAA
_0xAB:
	CP   R16,R20
	BRSH _0xAD
	SBRS R17,7
	RJMP _0xAE
	SBRS R17,2
	RJMP _0xAF
	ANDI R17,LOW(251)
	MOV  R19,R21
	SUBI R16,LOW(1)
	RJMP _0xB0
_0xAF:
	LDI  R19,LOW(48)
_0xB0:
	RJMP _0xB1
_0xAE:
	LDI  R19,LOW(32)
_0xB1:
	RCALL SUBOPT_0x7
	SUBI R20,LOW(1)
	RJMP _0xAB
_0xAD:
_0xAA:
	MOV  R18,R16
	SBRS R17,1
	RJMP _0xB2
_0xB3:
	CPI  R18,0
	BREQ _0xB5
	SBRS R17,3
	RJMP _0xB6
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0xFB
_0xB6:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0xFB:
	ST   -Y,R30
	RCALL SUBOPT_0xC
	CPI  R20,0
	BREQ _0xB8
	SUBI R20,LOW(1)
_0xB8:
	SUBI R18,LOW(1)
	RJMP _0xB3
_0xB5:
	RJMP _0xB9
_0xB2:
_0xBB:
	LDI  R19,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
                                      ldd  r26,y+10  ;R26,R27=n
                                      ldd  r27,y+11
                                  calc_digit:
                                      cp   r26,r30
                                      cpc  r27,r31
                                      brlo calc_digit_done
	SUBI R19,-LOW(1)
	                                  sub  r26,r30
	                                  sbc  r27,r31
	                                  brne calc_digit
                                  calc_digit_done:
                                      std  Y+10,r26 ;n=R26,R27
                                      std  y+11,r27
	LDI  R30,LOW(57)
	CP   R30,R19
	BRSH _0xBD
	SBRS R17,3
	RJMP _0xBE
	SUBI R19,-LOW(7)
	RJMP _0xBF
_0xBE:
	SUBI R19,-LOW(39)
_0xBF:
_0xBD:
	SBRC R17,4
	RJMP _0xC1
	LDI  R30,LOW(48)
	CP   R30,R19
	BRLO _0xC3
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BRNE _0xC2
_0xC3:
	ORI  R17,LOW(16)
	RJMP _0xC5
_0xC2:
	CP   R20,R18
	BRLO _0xC7
	SBRS R17,0
	RJMP _0xC8
_0xC7:
	RJMP _0xC6
_0xC8:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0xC9
	LDI  R19,LOW(48)
	ORI  R17,LOW(16)
_0xC5:
	SBRS R17,2
	RJMP _0xCA
	ANDI R17,LOW(251)
	ST   -Y,R21
	RCALL SUBOPT_0xC
	CPI  R20,0
	BREQ _0xCB
	SUBI R20,LOW(1)
_0xCB:
_0xCA:
_0xC9:
_0xC1:
	RCALL SUBOPT_0x7
	CPI  R20,0
	BREQ _0xCC
	SUBI R20,LOW(1)
_0xCC:
_0xC6:
	SUBI R18,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0xBC
	RJMP _0xBB
_0xBC:
_0xB9:
	SBRS R17,0
	RJMP _0xCD
_0xCE:
	CPI  R20,0
	BREQ _0xD0
	SUBI R20,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x9
	RJMP _0xCE
_0xD0:
_0xCD:
_0xD1:
_0x93:
	LDI  R16,LOW(0)
_0x7E:
	RJMP _0x79
_0x7B:
	RCALL __LOADLOCR6
	ADIW R28,18
	RET
_sprintf:
	MOV  R15,R24
	SBIW R28,4
	MOVW R26,R28
	RCALL __ADDW2R15
	STD  Y+2,R26
	STD  Y+2+1,R27
	MOVW R26,R28
	ADIW R26,6
	RCALL SUBOPT_0xD
	ST   Y,R30
	STD  Y+1,R31
	MOVW R26,R28
	ADIW R26,4
	RCALL SUBOPT_0xD
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G2
	LD   R26,Y
	LDD  R27,Y+1
	CLR  R30
	ST   X,R30
	RJMP _0xF9
_Lire_BP:

	.DSEG

	.CSEG
	RCALL __SAVELOCR2
	RCALL SUBOPT_0xE
	MOV  R30,R4
	CPI  R30,0
	BRNE _0xE1
	CPI  R17,63
	BRNE _0xE2
	MOV  R16,R17
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0xE
	CP   R17,R16
	BRNE _0xE3
	LDI  R30,LOW(1)
	MOV  R4,R30
	LDI  R30,LOW(255)
	RJMP _0xFA
_0xE3:
	CLR  R30
	RJMP _0xFA
	RJMP _0xE5
_0xE2:
	CLR  R30
	RJMP _0xFA
_0xE5:
	RJMP _0xE0
_0xE1:
	CPI  R30,LOW(0x1)
	BRNE _0xE0
	CPI  R17,63
	BREQ _0xE7
	MOV  R16,R17
	RCALL SUBOPT_0xF
	ANDI R17,LOW(63)
	CP   R17,R16
	BRNE _0xE8
	CLR  R4
	MOV  R30,R17
	RJMP _0xFA
_0xE8:
	LDI  R30,LOW(255)
	RJMP _0xFA
	RJMP _0xEA
_0xE7:
	LDI  R30,LOW(255)
_0xEA:
_0xE0:
_0xFA:
	RCALL __LOADLOCR2P
	RET
_Affiche_LCD:
	RCALL _lcd_clear
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x12
	RCALL _lcd_gotoxy
	LD   R30,Y
	LDD  R31,Y+1
	RCALL SUBOPT_0x10
_0xF9:
	ADIW R28,4
	RET
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G4:
	.BYTE 0x4

	.CSEG
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
__lcd_delay:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
    ret
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    ld    r26,y
    swap  r26
    rcall __lcd_write_nibble      ;write LSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
__lcd_read_nibble:
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    andi  r30,0xf0
    ret
_lcd_read_byte0_G4:
    rcall __lcd_delay
    rcall __lcd_read_nibble       ;read MSN
    mov   r26,r30
    rcall __lcd_read_nibble       ;read LSN
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	RCALL __lcd_ready
	LD   R30,Y
	CLR  R31
	SUBI R30,LOW(-__base_y_G4)
	SBCI R31,HIGH(-__base_y_G4)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	RCALL SUBOPT_0x13
	LDD  R5,Y+1
	LDD  R6,Y+0
	ADIW R28,2
	RET
_lcd_clear:
	RCALL __lcd_ready
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x13
	RCALL __lcd_ready
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x13
	RCALL __lcd_ready
	RCALL SUBOPT_0x12
	RCALL __lcd_write_data
	CLR  R30
	MOV  R6,R30
	MOV  R5,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	INC  R5
	CP   R7,R5
	BRSH _0xF2
	__lcd_putchar1:
	INC  R6
	RCALL SUBOPT_0x11
	ST   -Y,R6
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0xF2:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_puts:
    ldd  r31,y+1
    ld   r30,y
__lcd_puts0:
    ld   r26,z+
    tst  r26
    breq __lcd_puts1
    st   -y,r26    
    rcall _lcd_putchar
    rjmp __lcd_puts0
__lcd_puts1:
	ADIW R28,2
	RET
__long_delay_G4:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G4:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LDD  R7,Y+0
	LD   R30,Y
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G4,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G4,3
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x14
	RCALL __long_delay_G4
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_init_write_G4
	RCALL __long_delay_G4
	LDI  R30,LOW(40)
	RCALL SUBOPT_0x13
	RCALL __long_delay_G4
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x13
	RCALL __long_delay_G4
	LDI  R30,LOW(133)
	RCALL SUBOPT_0x13
	RCALL __long_delay_G4
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RCALL _lcd_read_byte0_G4
	CPI  R30,LOW(0x5)
	BREQ _0xF7
	CLR  R30
	RJMP _0xF8
_0xF7:
	RCALL __lcd_ready
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x13
	RCALL _lcd_clear
	LDI  R30,LOW(1)
_0xF8:
	ADIW R28,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x0:
	MOVW R30,R28
	ADIW R30,29
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	RCALL _sprintf
	ADIW R28,4
	MOVW R30,R28
	ADIW R30,12
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2:
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R16
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	MOV  R30,R18
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	MOV  R30,R21
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	RCALL _sprintf
	ADIW R28,16
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4:
	MOVW R30,R28
	ADIW R30,14
	ST   -Y,R31
	ST   -Y,R30
	RJMP _Affiche_LCD

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x5:
	LDI  R30,LOW(10)
	RCALL __DIVB21U
	CLR  R31
	MOVW R26,R28
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x7:
	ST   -Y,R19
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x8:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,4
	STD  Y+14,R26
	STD  Y+14+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9:
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xA:
	RCALL __GETD1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	RCALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xC:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xD:
	RCALL __ADDW2R15
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xE:
	IN   R30,0x19
	ANDI R30,LOW(0x3F)
	MOV  R17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xF:
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x10:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x11:
	CLR  R30
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x12:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x13:
	ST   -Y,R30
	RJMP __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x14:
	RCALL __long_delay_G4
	LDI  R30,LOW(48)
	ST   -Y,R30
	RJMP __lcd_init_write_G4

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__PUTWP1:
	ST   X+,R30
	ST   X,R31
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

