/*********************************************
This program was produced by the
CodeWizardAVR V1.24.0 Standard
Automatic Program Generator
 Copyright 1998-2003 HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : 
Version : 
Date    : 23/06/2008
Author  : perso                           
Company :                                 
Comments: 


Chip type           : ATmega8535
Program type        : Application
Clock frequency     : 8,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*********************************************/

#include <mega8535.h>

// Librairies non gnres par Wizard ( rajouter manuellement)
//-----------------------------------------------------------------      
#include <stdio.h>    // contient la fonction sprintf 
#include <delay.h>    // contient la fonction delay_ms

// Ces fichiers d'en-tte et les librairies correspondantes doivent tre placs
// dans les rpertoires c:/cvavr/inc et c:/cvavr/lib
// -------------------------------------------------------------------------------
#include <ssi.h> 	// Sous-programme Affiche_LCD, Lire_BP  
//**********************************************************************************  

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15
#endasm
#include <lcd.h>

// Declare your global variables here

void main(void)
{
// Declare your local variables here   
// -----------------------------------------------------------------------------------------
//type 		nom 					description  
// -----------------------------------------------------------------------------------------
char display_buffer_ligne0[17]; 			// tampon ligne 0 de l'afficheur
char display_buffer_ligne1[17]; 	       		// tampon ligne 1 de l'afficheur

unsigned char R=0,R_1=0,V=0,V_1=0,B_1=0,B=0;	// intensit lumineuse
unsigned char BP;					// Bouton-poussoir slectionn
 
// Coefficient pour le rglage du rapport cyclique du signal PWM
unsigned char alpha[11] = {0,25,51,76,102,127,153,178,204,229,255}; 

// Input/Output Ports initialization
// Port A initialization
// Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
// State0=P State1=P State2=P State3=P State4=P State5=P State6=T State7=T 
PORTA=0x3F;
DDRA=0x00;

// Port B initialization
// Func0=In Func1=In Func2=In Func3=Out Func4=In Func5=In Func6=In Func7=In 
// State0=T State1=T State2=T State3=0 State4=T State5=T State6=T State7=T 
PORTB=0x00;
DDRB=0x08;

// Port C initialization
// Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
// State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func0=In Func1=In Func2=In Func3=In Func4=Out Func5=Out Func6=In Func7=In 
// State0=T State1=T State2=T State3=T State4=0 State5=0 State6=T State7=T 
PORTD=0x00;
DDRD=0x30;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 31,250 kHz
// Mode: Phase correct PWM top=FFh
// OC0 output: Non-Inverted PWM
TCCR0=0x64;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 31,250 kHz
// Mode: Ph. correct PWM top=00FFh
// OC1A output: Non-Inv.
// OC1B output: Non-Inv.
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0xA1;
TCCR1B=0x04;
TCNT1H=0x00;
TCNT1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
// Analog Comparator Output: Off
ACSR=0x80;
SFIOR=0x00;

// LCD module initialization
lcd_init(16);

sprintf(display_buffer_ligne0,"Rouge Vert Bleu");
sprintf(display_buffer_ligne1,"%-u%%  %-u%%  %-u%%",R,V,B);
Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 

while (1)
      {
      BP = Lire_BP();
      if ((R != R_1) || (V != V_1) || (B != B_1))
      {
         sprintf(display_buffer_ligne0,"Rouge Vert Bleu");
         sprintf(display_buffer_ligne1,"%-u%%  %-u%%  %-u%%",R,V,B);
         Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
         R_1 = R; V_1 = V; B_1 = B;
      }
         switch(BP)
          {
            case INC: if (R < 90) R = R+10; else R = 100; break;
            case DEC: if (R > 10) R = R-10; else R = 0; break;
            case OK: if (V < 90) V = V+10; else V = 100; break;
            case SET: if (V > 10) V = V-10; else V = 0; break;
            case ECHAP : if (B < 90) B = B+10; else B = 100; break;
            case ENTR : if (B > 10) B = B-10; else B = 0; break;
          }
        OCR1AL=alpha[R/10];
        OCR1BL=alpha[V/10];
        OCR0=alpha[B/10];

      };
}
